#include <stdio.h>
#include <stdlib.h>
#include <time.h>

static double tic(void) { 
    return (clock()/ (double) CLOCKS_PER_SEC); 
}

static double toc(double t) { 
    double s = tic(); 
    if(s<t) return(0.0);
    return(s-t); 
}


// Inicializa todas las entradas del arreglo vec con el valor vinit
void inicializaVector1(int dim, double *vec, double vinit) {
    for(int i=0; i<dim; ++i) 
        vec[i] = vinit;
}

// Calcula la suma vec3 = vec1 + vec2
void sumaVectores1(int dim, double *vec1, double *vec2, double *vec3) {
    for(int i=0; i<dim; ++i) 
        vec3[i] = vec1[i] + vec2[i];
}

// Inicializa todas las entradas del arreglo vec con el valor vinit
void inicializaVector2(int dim, double *vec, double vinit) {
    double *ptr = vec;
    for(int i=0; i<dim; ++i, ++ptr) 
        *ptr = vinit;
}

// Calcula la suma vec3 = vec1 + vec2
void sumaVectores2(int dim, double *vec1, double *vec2, double *vec3) {
    double *ptr1=vec1, *ptr2=vec2, *ptr3=vec3;
    for(int i=0; i<dim; ++i, ++ptr1, ++ptr2, ++ptr3) 
        *ptr3 = *ptr1 + *ptr2;
}

int main(int argc, char **argv) {
    int dim = 5;
    double *vec1, *vec2, *vec3, tini, tfin;
   
    if(argc>1) dim = atoi(argv[1]);

    printf("Creando dos vectores de tama~no %d\n", dim);
    vec1 = (double *) malloc( dim*sizeof(double) );
    vec2 = (double *) calloc( dim, sizeof(double) );
    vec3 = new double[dim];

    if(vec1==NULL || vec2==NULL || vec3==NULL) {
        printf("Error al reservar memoria\n");
        return(0);
    }

    
    tini = tic();
    inicializaVector1(dim, vec1, 4.0);
    inicializaVector1(dim, vec2, 6.0);
    sumaVectores1(dim, vec1, vec2, vec3);
    tfin = toc(tini);
    printf("Inicializacion y suma 1. Tiempo final = %e  segundos\n", tfin);

    
    tini = tic();
    inicializaVector2(dim, vec1, 4.0);
    inicializaVector2(dim, vec2, 6.0);
    sumaVectores2(dim, vec1, vec2, vec3);
    tfin = toc(tini);
    printf("Inicializacion y suma 2. Tiempo final = %e  segundos\n", tfin);


    printf("Liberando memoria\n");
    free(vec1);
    free(vec2);
    delete[] vec3;

    return(0);
}

